#fonction pour calculer l'étendue
#max-min après un tri à bulles
etendue <- function(x){
  #copie locale (équiv. clone sous R)
  vec <- x
  n <- length(vec)
  #tri à bulles -- https://fr.wikipedia.org/wiki/Tri_à_bulles
  for (i in n:2){
    for (j in 1:(i-1)){
      if (vec[j+1] < vec[j]){
        temp <- vec[j+1]
        vec[j+1] <- vec[j]
        vec[j] <- temp
      }
    }
  }
  #calculer et renvoyer l'écart entre le min et le max après le tri
  return(vec[n]-vec[1])
}

#générer un vecteur
v <- runif(n=6000)

#calcul de l'étendue
print(etendue(v))

#temps de calcul
library(microbenchmark)
microbenchmark(etendue(v),times=5)

#librairie
library(Rcpp)

#"compiler" la fonction
Rcpp::sourceCpp("bulle.cpp")

#appel de la fonction
print(rcpp_etendue(v))

#temps de traitement
microbenchmark(rcpp_etendue(v),times=5)
